//  ************************************************************************************************
//
//  BornAgain: simulate and fit reflection and scattering
//
//! @file      Sample/HardParticle/LongBoxGauss.cpp
//! @brief     Implements class LongBoxGauss.
//!
//! @homepage  http://www.bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Jülich GmbH 2018
//! @authors   Scientific Computing Group at MLZ (see CITATION, AUTHORS)
//
//  ************************************************************************************************

#include "Sample/HardParticle/LongBoxGauss.h"
#include "Base/Math/Functions.h"
#include "Sample/Shape/BoxNet.h"

LongBoxGauss::LongBoxGauss(double length, double width, double height)
    : HardFormfactor()
    , m_length(length)
    , m_width(width)
    , m_height(height)
{
    LongBoxGauss::validate();
}

void LongBoxGauss::validate() const
{
    if (m_length <= 0)
        throw std::runtime_error("length <= 0");
    if (m_width <= 0)
        throw std::runtime_error("width <= 0");
    if (m_height <= 0)
        throw std::runtime_error("height <= 0");

    m_shape3D = std::make_unique<BoxNet>(m_length, m_width, m_height);

    m_validated = true;
}

complex_t LongBoxGauss::formfactorAtBottom(C3 q) const
{
    complex_t qxL2 = std::pow(m_length * q.x(), 2) / 2.0;
    complex_t qyWdiv2 = m_width * q.y() / 2.0;
    complex_t qzHdiv2 = m_height * q.z() / 2.0;

    return m_height * m_length * m_width * exp_I(qzHdiv2) * std::exp(-qxL2) * Math::sinc(qyWdiv2)
           * Math::sinc(qzHdiv2);
}


bool LongBoxGauss::contains(const R3&) const
{
    throw std::runtime_error("LongBoxGauss cannot be used as mesocrystal outer shape");
}
